{ ****************************************************************** }
{                                                                    }
{   VCL component TDKFileFinder                                      }
{                                                                    }
{   dotKNOT File Finder                                              }
{                                                                    }
{   Code generated by Component Create for Delphi                    }
{                                                                    }
{   Generated from source file c:\program files\component create\dkfilefinder.cd }
{   on 23 Dec 2004 at 12:56                                          }
{                                                                    }
{   Copyright  2004 by Jon@Knot-Technology.co.uk                    }
{                                                                    }
{ ****************************************************************** }

unit DKFileFinder;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls, 
     Forms, Graphics, StrUtils;

type
  TDKFileFinder = class(TComponent)
    private
      { Private fields of TDKFileFinder }
        FFileMask : String;
        FFilesFound : TStrings;
        FPath : String;

      { Private methods of TDKFileFinder }
        { Method to set variable and property values and create objects }
        procedure AutoInitialize;
        { Method to free any objects created by AutoInitialize }
        procedure AutoDestroy;
        procedure SetFilesFound(Value : TStrings);
        procedure GetFiles(const DirStr : String);

    protected
      { Protected fields of TDKFileFinder }

      { Protected methods of TDKFileFinder }
        procedure Loaded; override;

    public
      { Public fields and properties of TDKFileFinder }

      { Public methods of TDKFileFinder }
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;
        function Execute : Boolean;

    published
      { Published properties of TDKFileFinder }
        property FileMask : String read FFileMask write FFileMask;
        property FilesFound : TStrings read FFilesFound write SetFilesFound;
        property Path : String read FPath write FPath;

  end;

procedure Register;

implementation

procedure Register;
begin
     { Register TDKFileFinder with dotKNOT as its
       default page on the Delphi component palette }
     RegisterComponents('dotKNOT', [TDKFileFinder]);
end;

{ Method to set variable and property values and create objects }
procedure TDKFileFinder.AutoInitialize;
begin
     FFileMask := '*.*';
     FFilesFound := TStringList.Create;
     FPath := 'C:\';
end; { of AutoInitialize }

{ Method to free any objects created by AutoInitialize }
procedure TDKFileFinder.AutoDestroy;
begin
     FFilesFound.Free;
end; { of AutoDestroy }

procedure TDKFileFinder.SetFilesFound(Value : TStrings);
begin
     { Use Assign method because TStrings is an object type
       and FFileFound has been created. }
     FFilesFound.Assign(Value);
end;

constructor TDKFileFinder.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     AutoInitialize;
     
     { Code to perform other tasks when the component is created }
     
end;

destructor TDKFileFinder.Destroy;
begin
     AutoDestroy;
     inherited Destroy;
end;

function TDKFileFinder.Execute : Boolean;
begin
     FilesFound.clear;
     Screen.Cursor := crHourGlass;
     GetFiles(fPath);
     Screen.Cursor := crDefault;
     Result := True
end;

procedure TDKFileFinder.GetFiles(const DirStr : String);
var
  DirInfo: TSearchRec;
  rd,rf : Integer;
begin
  rf := FindFirst(IncludeTrailingBackslash(DirStr) + fFileMask, FaAnyfile, DirInfo);
  while rf = 0 do  begin
    Application.ProcessMessages;
    if ((DirInfo.Attr and FaDirectory <> FaDirectory) and
        (DirInfo.Attr and FaVolumeId <> FaVolumeID)) then
      fFilesFound.Add(IncludeTrailingBackslash(DirStr) + DirInfo.Name);
    rf := FindNext(DirInfo);
  end;
  SysUtils.FindClose(DirInfo);
  rd := FindFirst(IncludeTrailingBackslash(DirStr) + '*.*', FaAnyfile, DirInfo);
  while rd = 0 do  begin
    Application.ProcessMessages;
    if ((DirInfo.Attr and FaDirectory = FaDirectory) and
         (DirInfo.Name <> '.') and
         (DirInfo.Name <> '..'))  then
         GetFiles(IncludeTrailingBackslash(DirStr) + IncludeTrailingBackslash(DirInfo.Name));
    rd := FindNext(DirInfo);
  end;
  SysUtils.FindClose(DirInfo);
end;

procedure TDKFileFinder.Loaded;
begin
     inherited Loaded;

     { Perform any component setup that depends on the property
       values having been set }

end;


end.
